﻿'UTF8
Option Strict On

Public Class frmMain

    Private Const SQL_SELECT As String = "SELECT [imagefield] FROM [tablename] WHERE ([keyfield] = @keyfield);"
    Private Const SQL_INSERT As String = "INSERT INTO [tablename]([imagefield], [keyfield]) VALUES(@imagefield ,@keyfield);"
    Private Const SQL_UPDATE As String = "UPDATE [tablename] SET [imagefield] = @imagefield WHERE ([keyfield] = @keyfield);"
    Private Const SQL_DELETE As String = "DELETE FROM [tablename] WHERE ([keyfield] = @keyfield);"
    Private Const SQL_EXISTS As String = "SELECT COUNT(*) FROM [tablename] WHERE ([keyfield] = @keyfield);"

    Private Const CONNECTIONSTRING As String = "Provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=""|DataDirectory|DataBase.mdb"""

#Region " Events "

    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        Me.f_Picture.Image = Me.LoadImage(CInt(Me.f_ID.Value))
    End Sub

    Private Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If _
            (Me.OFD.ShowDialog(Me) <> System.Windows.Forms.DialogResult.OK) OrElse _
            (String.IsNullOrEmpty(Me.OFD.FileName)) Then Return
        '------------------------------------------------------------
        Dim ikeyfield As Integer = CInt(Me.f_ID.Value)
        Me.SaveImage(ikeyfield, Me.OFD.FileName)
        Me.f_Picture.Image = Me.LoadImage(ikeyfield)
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        Dim ikeyfield As Integer = CInt(Me.f_ID.Value)
        Me.DeleteImage(ikeyfield)
        Me.f_Picture.Image = Me.LoadImage(ikeyfield)
    End Sub

#End Region

#Region " Engine "

    Private Function LoadImage(ByVal keyfield As Integer) As System.Drawing.Image
        Try
            Using _
                dbCon As New System.Data.OleDb.OleDbConnection(CONNECTIONSTRING), _
                dbCom As New System.Data.OleDb.OleDbCommand(SQL_SELECT, dbCon)

                dbCom.Parameters.AddWithValue("@keyfield", keyfield)

                dbCon.Open()
                Dim buffer() As Byte = TryCast(dbCom.ExecuteScalar, Byte())
                dbCon.Close()

                If (buffer IsNot Nothing) AndAlso (buffer.Length > 0) Then
                    Using strm As New System.IO.MemoryStream(buffer)
                        Return System.Drawing.Image.FromStream(strm)
                    End Using
                End If
            End Using
        Catch
            'Return Nothing
        End Try
        '------------------------------------------------------------
        Return Nothing
    End Function

    Private Function SaveImage(ByVal keyfield As Integer, ByVal imagefilepath As String) As Boolean
        Try
            Using bmp As System.Drawing.Image = System.Drawing.Image.FromFile(imagefilepath)
                If (bmp Is Nothing) Then Return False
                Return Me.SaveImage(keyfield, bmp)
            End Using

        Catch
            Return False
        End Try
    End Function

    Private Function SaveImage(ByVal keyfield As Integer, ByVal imagefield As System.Drawing.Image) As Boolean
        Dim bIsExist As Boolean
        '------------------------------------------------------------
        Try
            Using _
                dbCon As New System.Data.OleDb.OleDbConnection(CONNECTIONSTRING), _
                dbCom As New System.Data.OleDb.OleDbCommand(SQL_EXISTS, dbCon)

                dbCom.Parameters.AddWithValue("@keyfield", keyfield)

                dbCon.Open()

                Try
                    bIsExist = CInt(dbCom.ExecuteScalar) > 0
                Catch
                    bIsExist = False
                End Try
                '------------------------------------------------------------
                dbCom.Parameters.Clear()
                dbCom.Parameters.AddRange( _
                   New System.Data.OleDb.OleDbParameter() { _
                   New System.Data.OleDb.OleDbParameter("@imagefield", System.Data.OleDb.OleDbType.VarBinary, 0, System.Data.ParameterDirection.Input, True, CByte(0), CByte(0), Nothing, System.Data.DataRowVersion.Current, Nothing), _
                   New System.Data.OleDb.OleDbParameter("@keyfield", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, False, CByte(0), CByte(0), Nothing, System.Data.DataRowVersion.Current, keyfield)})

                If (imagefield Is Nothing) Then
                    dbCom.Parameters(0).Value = System.DBNull.Value
                Else
                    Using strm As New System.IO.MemoryStream
                        imagefield.Save(strm, System.Drawing.Imaging.ImageFormat.Jpeg)
                        dbCom.Parameters(0).Value = strm.ToArray
                    End Using
                End If
                '------------------------------------------------------------
                'VB9 (2008)
                dbCom.CommandText = If(bIsExist, SQL_UPDATE, SQL_INSERT)
                'VB7,8,9
                'If bIsExist Then dbCom.CommandText = SQL_UPDATE Else dbCom.CommandText = SQL_INSERT
                '------------------------------------------------------------
                Return dbCom.ExecuteNonQuery > 0
            End Using

        Catch
            Return False
        End Try
    End Function

    Private Function DeleteImage(ByVal keyfield As Integer) As Boolean
        Try
            Using _
                dbCon As New System.Data.OleDb.OleDbConnection(CONNECTIONSTRING), _
                dbCom As New System.Data.OleDb.OleDbCommand(SQL_DELETE, dbCon)

                dbCom.Parameters.AddWithValue("@keyfield", keyfield)

                dbCon.Open()
                Return dbCom.ExecuteNonQuery > 0
            End Using

        Catch
            Return False
        End Try
    End Function

#End Region



    <STAThread()> Public Shared Sub Main()
        System.Windows.Forms.Application.EnableVisualStyles()
        Using f As New frmMain
            System.Windows.Forms.Application.Run(f)
        End Using
    End Sub

End Class
